#RAEDQuickSignal (c) RAED 07-02-2014
#Based on 2boom & big-town Plugins
#Update V 2.9 by RAED 27-11-2016 fix FHD Skins
#Update V 3.0 by RAED 16-08-2018 make skins in separate file 
#Update V 3.1 by RAED 17-08-2018 Add Enable/Disable, menu buttons function (Thx mfaraj for help)
#Update V 3.2 by RAED 10-09-2018 Add more Buttons function + Add Version number + Add time and date
#Update V 3.6 by RAED 10-12-2018 Support DreamOs images
#Update V 3.7 by RAED 10-12-2018 changes name of plugins
#Update V 4.0 by RAED 10-12-2018 Add some option
#Update V 3.3 by RAED 10-12-2018 Add weather option

from Components.ActionMap import ActionMap
from Components.config import config, getConfigListEntry, ConfigText, ConfigInteger, ConfigClock, ConfigSelection, ConfigSubsection, ConfigYesNo, configfile, NoSave
from Components.ConfigList import ConfigListScreen
from GlobalActions import globalActionMap
from keymapparser import readKeymap, removeKeymap
from enigma import ePoint, eTimer, getDesktop
from Components.Pixmap import Pixmap
from os import environ
from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Tools.Directories import resolveFilename, SCOPE_LANGUAGE, SCOPE_PLUGINS
from Screens.Standby import TryQuitMainloop
import gettext
from Screens.MessageBox import MessageBox
from Tools.Directories import fileExists
from Components.Language import language
from Components.Sources.StaticText import StaticText
from Tools.Directories import *
from Components.config import *
from Screens.InputBox import InputBox
from Components.MenuList import MenuList
from Tools.RaedQuickWeatherID import get_woeid_from_yahoo
from Components.Label import Label
import os
from os import environ
import datetime
import shutil
import re


Ver = "4.3"
now = datetime.datetime.now()
datetime_now = (now.strftime("%Y-%m-%d  %H:%M"))
lang = language.getLanguage()
environ["LANGUAGE"] = lang[:2]
gettext.bindtextdomain("enigma2", resolveFilename(SCOPE_LANGUAGE))
gettext.textdomain("enigma2")
gettext.bindtextdomain("qei", "%s%s" % (resolveFilename(SCOPE_PLUGINS), "Extensions/RaedQuickSignal/locale/"))

def _(txt):
        t = gettext.dgettext("qei", txt)
        if t == txt:
                t = gettext.gettext(txt)
        return t


def logdata(label_name = '', data = None):
    try:
           
        data=str(data)
        
        fp = open('/tmp/RaedQuickSignal.log', 'a')
        fp.write( str(label_name) + ': ' + data+"\n")
        fp.close()
    except:
        pass

def dellog(label_name = '', data = None):
    try:
           
        import os
        
        if os.path.exists('/tmp/RaedQuickSignal.log'):
                os.remove('/tmp/RaedQuickSignal.log')
       
    except:
        pass
##############################################################################
if getDesktop(0).size().width() == 1280:
        Space = "             "
        SKIN_setup = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/Setup.xml"
        SKIN_WeatherLocation = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/WeatherLocation.xml"
        SKIN_AGC_Picon = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/AGC_Picon.xml"
        SKIN_AGC_Event_Des = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/AGC_Event_Des.xml"
        SKIN_AGC_Weather = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/AGC_Weather.xml"
        SKIN_Event_Progress_Picon = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/Event_Progress_Picon.xml"
        SKIN_Event_Progress_Event_Des = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/Event_Progress_Event_Des.xml"
        SKIN_Event_Progress_Weather = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/Event_Progress_Weather.xml"

else:
        Space = "                                          "
        SKIN_setup = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/Setup_FHD.xml"
        SKIN_WeatherLocation = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/WeatherLocation.xml"
        SKIN_AGC_Picon = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/AGC_Picon_FHD.xml"
        SKIN_AGC_Event_Des = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/AGC_Event_Des_FHD.xml"
        SKIN_AGC_Weather = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/AGC_Weather_FHD.xml"
        SKIN_Event_Progress_Picon = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/Event_Progress_Picon_FHD.xml"
        SKIN_Event_Progress_Event_Des = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/Event_Progress_Event_Des_FHD.xml"
        SKIN_Event_Progress_Weather = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/screens/Event_Progress_Weather_FHD.xml"
##############################################################################
config.plugins.RaedQuickSignal = ConfigSubsection()
config.plugins.RaedQuickSignal.enabled = ConfigYesNo(default=True)
#config.plugins.RaedQuickSignal.shown = ConfigYesNo(default=False)
config.plugins.RaedQuickSignal.keyname = ConfigSelection(default = "KEY_TEXT", choices = [
                ("KEY_TEXT", "TEXT"),
                ("KEY_TV", "TV"),
                ("KEY_RADIO", "RADIO"),
                ("KEY_OK", "OK"),
                ("KEY_EXIT", "EXIT"),
                ("KEY_HELP", "HELP"),
                ("KEY_INFO", "INFO"),
                ("KEY_RED", "RED"),
                ("KEY_GREEN", "GREEN"),
                ("KEY_BLUE", "BLUE"),
                ("KEY_PVR", "PVR"),
                ("KEY_0", "0"),
                ("KEY_1", "1"),
                ("KEY_2", "2"),
                ("KEY_3", "3"),
                ])
config.plugins.RaedQuickSignal.style = ConfigSelection(default = "AGC1", choices = [
                ("AGC1", "AGC Progress + Picon"),
                ("AGC2", "AGC Progress + Event Description"),
                ("AGC3", "AGC Progress + Weather"),
                ("Event1", "Event Progress + Picon"),
                ("Event2", "Event Progress + Event Description"),
                ("Event3", "Event Progress + Weather"),
                ])
config.plugins.RaedQuickSignal.refreshInterval = ConfigNumber(default=30) #in minutes
config.plugins.RaedQuickSignal.woeid = ConfigNumber(default=56438032) #Location Warsaw (visit weather.yahoo.com)
config.plugins.RaedQuickSignal.tempUnit = ConfigSelection(default="Celsius", choices = [
                ("Celsius", _("Celsius")),
                ("Fahrenheit", _("Fahrenheit"))
                ])
##############################################################################
def isInteger(s):
	try: 
		int(s)
		return True
	except ValueError:
		return False

class WeatherLocationChoiceList(Screen):
	def __init__(self, session, location_list):
                with open(SKIN_WeatherLocation, 'r') as f:
                     self.skin = f.read()
                     f.close()
		self.session = session
		self.location_list = location_list
		list = []
		Screen.__init__(self, session)
		self.title = _("Location list")
		self["choicelist"] = MenuList(list)
		self["key_red"] = Label(_("Cancel"))
		self["key_green"] = Label(_("OK"))
		self["myActionMap"] = ActionMap(["SetupActions", "ColorActions"],
		{
			"ok": self.keyOk,
			"green": self.keyOk,
			"cancel": self.keyCancel,
			"red": self.keyCancel,
		}, -1)
		self.createChoiceList()

	def createChoiceList(self):
		list = []
		for x in self.location_list:
			list.append((str(x[1]), str(x[0])))
		self["choicelist"].l.setList(list)

	def keyOk(self):
		returnValue = self["choicelist"].l.getCurrentSelection()[1]
		if returnValue is not None:
			self.close(returnValue)
		else:
			self.keyCancel()

	def keyCancel(self):
		self.close(None)

class RaedQuickSignalScreen(Screen):
        def __init__(self, session):
                Screen.__init__(self, session)
                dellog()
                if config.plugins.RaedQuickSignal.style.value == "AGC1":
                        with open(SKIN_AGC_Picon, 'r') as f:
                             self.skin = f.read()
                             f.close()
                elif config.plugins.RaedQuickSignal.style.value == "AGC2":
                        with open(SKIN_AGC_Event_Des, 'r') as f:
                             self.skin = f.read()
                             f.close()
                elif config.plugins.RaedQuickSignal.style.value == "AGC3":
                        with open(SKIN_AGC_Weather, 'r') as f:
                             self.skin = f.read()
                             f.close()
                elif config.plugins.RaedQuickSignal.style.value == "Event1":
                        with open(SKIN_Event_Progress_Picon, 'r') as f:
                             self.skin = f.read()
                             f.close()
                elif config.plugins.RaedQuickSignal.style.value == "Event2":
                        with open(SKIN_Event_Progress_Event_Des, 'r') as f:
                             self.skin = f.read()
                             f.close()
                elif config.plugins.RaedQuickSignal.style.value == "Event3":
                        with open(SKIN_Event_Progress_Weather, 'r') as f:
                             self.skin = f.read()
                             f.close()
                self.session=session
                self["setupActions"] = ActionMap(["SetupActions",'MenuActions'],
                                {"cancel": self.exit,'menu':self.showsetup}, -2)
                shown=True
                self.onLayoutFinish.append(self.layoutFinished)

                
        def layoutFinished(self):
                self.instance.show()
                self.setTitle("Quicksingal by RAED V" + str(Ver + Space + datetime_now))
                cfile=open("/tmp/.qsignal","w")
                cfile.close()

        def exit(self):
                if os.path.exists("/tmp/.qsignal"):
                        os.remove("/tmp/.qsignal")
                self.close()
        def setupback(self,answer=False):
                if answer:
                        self.exit()
                        
        def showsetup(self):
                self.session.openWithCallback(self.setupback,qei_setup)
##############################################################################
class RaedQuickSignal():
        def __init__(self):
                self.dialog = None

        def gotSession(self, session):
                self.session = session
                self.qsignal=None
                if os.path.exists("/tmp/.qsignal"):
                                  os.remove("/tmp/.qsignal")

                
                keymap = "/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/keymap.xml"
                global globalActionMap
                readKeymap(keymap)
                if 'displayHelp' in globalActionMap.actions:
                        del globalActionMap.actions['displayHelp']
                elif 'showSherlock' in globalActionMap.actions:
                        del globalActionMap.actions['showSherlock']
                globalActionMap.actions['showRaedQuickSignal'] = self.ShowHide
##############################################################################
        def ShowHide(self):

                
                if os.path.exists("/tmp/.qsignal")==False:
                        if config.plugins.RaedQuickSignal.enabled.value:
                                self.session.open(RaedQuickSignalScreen)
##############################################################################
pSignal = RaedQuickSignal()
##############################################################################
class qei_setup(ConfigListScreen, Screen):
        def __init__(self, session):
                self.session = session
                Screen.__init__(self, session)
                with open(SKIN_setup, 'r') as f:
                     self.skin = f.read()
                     f.close()
                self.setTitle(_("RAED's RaedQuickSignal setup V" + Ver))
                self.RaedQuickSignal_fake_entry = NoSave(ConfigNothing())
                self.list = []
                ConfigListScreen.__init__(self, self.list)

                self["key_red"] = StaticText(_("Close"))
                self["key_green"] = StaticText(_("Save"))
                self["key_yellow"] = StaticText(_(" "))
                self["key_blue"] = StaticText(_(" "))
                self["setupActions"] = ActionMap(["SetupActions", "ColorActions", "EPGSelectActions"],
                {
                        "red": self.cancel,
                        "cancel": self.cancel,
                        "green": self.save,
                        #"yellow": self.restart,
                        #"blue": self.keyOk,
                        "ok": self.keyOk
                }, -2)
                self.createConfigList()
        def run(self):
                  self.session.open(RaedQuickSignalScreen)
                
        def createConfigList(self):
                self.find_woeid = getConfigListEntry(_("Search weather location ID"), ConfigNothing())
                self.list = []
                self.currenabled_value=config.plugins.RaedQuickSignal.enabled.value
                self.currkeyname_value=config.plugins.RaedQuickSignal.keyname.value
                self.currwoeid_value=config.plugins.RaedQuickSignal.woeid.value
                self.list.append(getConfigListEntry(_("Enable Plugin"), config.plugins.RaedQuickSignal.enabled))
                self.list.append(getConfigListEntry(_("Select key to show RaedQuickSignal"), config.plugins.RaedQuickSignal.keyname))
                self.list.append(getConfigListEntry(_("Select Style of Plugin"), config.plugins.RaedQuickSignal.style))
                self.list.append(getConfigListEntry(_("---Yahoo Weather---"), self.RaedQuickSignal_fake_entry))
                self.list.append(getConfigListEntry(_("Refresh interval in minutes:"), config.plugins.RaedQuickSignal.refreshInterval))
                self.list.append(getConfigListEntry(_("Temperature unit:"), config.plugins.RaedQuickSignal.tempUnit))
                #self.list.append(self.find_woeid)
                self.list.append(getConfigListEntry(_("Location #press OK to change:"), config.plugins.RaedQuickSignal.woeid))
                self["config"].list = self.list
                self["config"].l.setList(self.list)

        def cancel(self):
                for i in self["config"].list:
                        i[1].cancel()
                self.close(False)
                
        def restart(self,answer=None):
                if answer:
                   self.session.open(TryQuitMainloop, 3)
                   return
                self.close(True)
        def search_weather_id_callback(self, res):
		if res:
			id_dic = get_woeid_from_yahoo(res)
			if id_dic.has_key('error'):
				error_txt = id_dic['error']
				self.session.open(MessageBox, _("Sorry, there was a problem:") + "\n%s" % error_txt, MessageBox.TYPE_ERROR)
			elif id_dic.has_key('count'):
				result_no = int(id_dic['count'])
				location_list = []
				for i in range(0, result_no):
					location_list.append(id_dic[i])
				self.session.openWithCallback(self.select_weather_id_callback, WeatherLocationChoiceList, location_list)

        def select_weather_id_callback(self, res):
		if res and isInteger(res):
			config.plugins.RaedQuickSignal.woeid.value = int(res)

        def keyOk(self):
            if self["config"].getCurrent()[1] == config.plugins.RaedQuickSignal.woeid:
            	self.session.openWithCallback(self.search_weather_id_callback, InputBox, title = _("Please enter search string for your location"), text = "")
            

        def save(self):

                if self["config"].isChanged():
                     
                
                        for x in self['config'].list:
                            x[1].save()

                        configfile.save()
                        
                        keyfile = open("/usr/lib/enigma2/python/Plugins/Extensions/RaedQuickSignal/keymap.xml", "w")
                        keyfile.write('<keymap>\n\t<map context="GlobalActions">\n\t\t<key id="%s" mapto="showRaedQuickSignal" flags="m" />\n\t</map>\n</keymap>' % config.plugins.RaedQuickSignal.keyname.value)
                        keyfile.close()
                        if not self.currenabled_value==config.plugins.RaedQuickSignal.enabled.value or not self.currkeyname_value==config.plugins.RaedQuickSignal.keyname.value or not self.currwoeid_value==config.plugins.RaedQuickSignal.woeid.value:
                       
                           self.session.openWithCallback(self.restart, MessageBox, _("Settings changed,restart enigma2 now?"))
                        else:
                                self.close(True)
                else:
                        self.close(False)
##############################################################################
def sessionstart(reason,session=None, **kwargs):
        if reason == 0:
                pSignal.gotSession(session)
                
##############################################################################
def main(session, **kwargs):
        session.open(qei_setup)
##############################################################################
def Plugins(**kwargs):
        result = [
                PluginDescriptor(
                        where = [PluginDescriptor.WHERE_SESSIONSTART],
                        fnc = sessionstart
                ),
                PluginDescriptor(
                        name=_("RaedQuickSignal Setup"),
                        description = _("RAED's RaedQuickSignal setup"),
                        where = PluginDescriptor.WHERE_PLUGINMENU,
                        icon = 'qei.png',
                        fnc = main
                ),
        ]
        return result
