from urllib2 import urlopen, URLError,ssl
from urllib import urlencode
import sys
import re
import json
WOEID_SEARCH_URL = 'https://query.yahooapis.com/v1/public/yql'
WOEID_QUERY_STRING = 'select * from geo.places(10) where text="%s"'

def get_woeid_from_yahoo(search_string):
    encoded_string = search_string.encode('utf-8')
    params = {'q': WOEID_QUERY_STRING % encoded_string,
     'format': 'json'}
    url = '?'.join((WOEID_SEARCH_URL, urlencode(params)))
    print "url",url
    try:
        
        handler = urlopen(url, timeout=10,context=ssl._create_unverified_context())
    except URLError:
        return {'error': _('Could not connect to server')}

    content_type = handler.info().dict['content-type']
    try:
        charset = re.search('charset\\=(.*)', content_type).group(1)
    except AttributeError:
        charset = 'utf-8'

    if charset.lower() != 'utf-8':
        json_response = handler.read().decode(charset).encode('utf-8')
    else:
        json_response = handler.read()
    handler.close()
    yahoo_woeid_result = json.loads(json_response)
    try:
        result = yahoo_woeid_result['query']['results']['place']
    except KeyError:
        return yahoo_woeid_result
    except TypeError:
        return {'error': _('No matching place names found')}

    woeid_data = {}
    woeid_data['count'] = yahoo_woeid_result['query']['count']
    for i in xrange(yahoo_woeid_result['query']['count']):
        try:
            place_data = result[i]
        except KeyError:
            place_data = result

        try:
            place_data1 = place_data['admin1']['code']
            if not place_data1 == '':
                place_data1 = ', ' + place_data1
        except:
            place_data1 = ''

        try:
            place_data2 = place_data['admin2']['content']
            if not place_data2 == '':
                place_data2 = ', ' + place_data2
        except:
            place_data2 = ''

        place_name = place_data['name'] + place_data1 + place_data2
        place_data = place_data['woeid']
        woeid_data[i] = (place_data, place_name)

    return woeid_data
